/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-r2-msgs-1.0.0-1raring-20150329-2316/msg/JointStatus.msg
 *
 */


#ifndef R2_MSGS_MESSAGE_JOINTSTATUS_H
#define R2_MSGS_MESSAGE_JOINTSTATUS_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace r2_msgs
{
template <class ContainerAllocator>
struct JointStatus_
{
  typedef JointStatus_<ContainerAllocator> Type;

  JointStatus_()
    : publisher()
    , joint()
    , registerValue(0)
    , bridgeEnabled(false)
    , motorEnabled(false)
    , brakeReleased(false)
    , motorPowerDetected(false)
    , embeddedMotCom(false)
    , jointFaulted(false)  {
    }
  JointStatus_(const ContainerAllocator& _alloc)
    : publisher(_alloc)
    , joint(_alloc)
    , registerValue(0)
    , bridgeEnabled(false)
    , motorEnabled(false)
    , brakeReleased(false)
    , motorPowerDetected(false)
    , embeddedMotCom(false)
    , jointFaulted(false)  {
    }



   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _publisher_type;
  _publisher_type publisher;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _joint_type;
  _joint_type joint;

   typedef uint32_t _registerValue_type;
  _registerValue_type registerValue;

   typedef uint8_t _bridgeEnabled_type;
  _bridgeEnabled_type bridgeEnabled;

   typedef uint8_t _motorEnabled_type;
  _motorEnabled_type motorEnabled;

   typedef uint8_t _brakeReleased_type;
  _brakeReleased_type brakeReleased;

   typedef uint8_t _motorPowerDetected_type;
  _motorPowerDetected_type motorPowerDetected;

   typedef uint8_t _embeddedMotCom_type;
  _embeddedMotCom_type embeddedMotCom;

   typedef uint8_t _jointFaulted_type;
  _jointFaulted_type jointFaulted;




  typedef boost::shared_ptr< ::r2_msgs::JointStatus_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::r2_msgs::JointStatus_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct JointStatus_

typedef ::r2_msgs::JointStatus_<std::allocator<void> > JointStatus;

typedef boost::shared_ptr< ::r2_msgs::JointStatus > JointStatusPtr;
typedef boost::shared_ptr< ::r2_msgs::JointStatus const> JointStatusConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::r2_msgs::JointStatus_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::r2_msgs::JointStatus_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace r2_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg'], 'r2_msgs': ['/tmp/buildd/ros-hydro-r2-msgs-1.0.0-1raring-20150329-2316/msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'visualization_msgs': ['/opt/ros/hydro/share/visualization_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::r2_msgs::JointStatus_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::r2_msgs::JointStatus_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::r2_msgs::JointStatus_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::r2_msgs::JointStatus_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::r2_msgs::JointStatus_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::r2_msgs::JointStatus_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::r2_msgs::JointStatus_<ContainerAllocator> >
{
  static const char* value()
  {
    return "03efe3c55d2652ccbab38921d83a5f63";
  }

  static const char* value(const ::r2_msgs::JointStatus_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x03efe3c55d2652ccULL;
  static const uint64_t static_value2 = 0xbab38921d83a5f63ULL;
};

template<class ContainerAllocator>
struct DataType< ::r2_msgs::JointStatus_<ContainerAllocator> >
{
  static const char* value()
  {
    return "r2_msgs/JointStatus";
  }

  static const char* value(const ::r2_msgs::JointStatus_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::r2_msgs::JointStatus_<ContainerAllocator> >
{
  static const char* value()
  {
    return "string publisher\n\
string joint\n\
uint32 registerValue\n\
bool bridgeEnabled\n\
bool motorEnabled\n\
bool brakeReleased\n\
bool motorPowerDetected\n\
bool embeddedMotCom\n\
bool jointFaulted\n\
";
  }

  static const char* value(const ::r2_msgs::JointStatus_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::r2_msgs::JointStatus_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.publisher);
      stream.next(m.joint);
      stream.next(m.registerValue);
      stream.next(m.bridgeEnabled);
      stream.next(m.motorEnabled);
      stream.next(m.brakeReleased);
      stream.next(m.motorPowerDetected);
      stream.next(m.embeddedMotCom);
      stream.next(m.jointFaulted);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct JointStatus_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::r2_msgs::JointStatus_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::r2_msgs::JointStatus_<ContainerAllocator>& v)
  {
    s << indent << "publisher: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.publisher);
    s << indent << "joint: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.joint);
    s << indent << "registerValue: ";
    Printer<uint32_t>::stream(s, indent + "  ", v.registerValue);
    s << indent << "bridgeEnabled: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.bridgeEnabled);
    s << indent << "motorEnabled: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.motorEnabled);
    s << indent << "brakeReleased: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.brakeReleased);
    s << indent << "motorPowerDetected: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.motorPowerDetected);
    s << indent << "embeddedMotCom: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.embeddedMotCom);
    s << indent << "jointFaulted: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.jointFaulted);
  }
};

} // namespace message_operations
} // namespace ros

#endif // R2_MSGS_MESSAGE_JOINTSTATUS_H
