/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-r2-msgs-1.0.0-1raring-20150329-2316/msg/PoseCommandArray.msg
 *
 */


#ifndef R2_MSGS_MESSAGE_POSECOMMANDARRAY_H
#define R2_MSGS_MESSAGE_POSECOMMANDARRAY_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <std_msgs/Header.h>
#include <r2_msgs/PoseCommand.h>

namespace r2_msgs
{
template <class ContainerAllocator>
struct PoseCommandArray_
{
  typedef PoseCommandArray_<ContainerAllocator> Type;

  PoseCommandArray_()
    : header()
    , command()  {
    }
  PoseCommandArray_(const ContainerAllocator& _alloc)
    : header(_alloc)
    , command(_alloc)  {
    }



   typedef  ::std_msgs::Header_<ContainerAllocator>  _header_type;
  _header_type header;

   typedef std::vector< ::r2_msgs::PoseCommand_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::r2_msgs::PoseCommand_<ContainerAllocator> >::other >  _command_type;
  _command_type command;




  typedef boost::shared_ptr< ::r2_msgs::PoseCommandArray_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::r2_msgs::PoseCommandArray_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct PoseCommandArray_

typedef ::r2_msgs::PoseCommandArray_<std::allocator<void> > PoseCommandArray;

typedef boost::shared_ptr< ::r2_msgs::PoseCommandArray > PoseCommandArrayPtr;
typedef boost::shared_ptr< ::r2_msgs::PoseCommandArray const> PoseCommandArrayConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::r2_msgs::PoseCommandArray_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::r2_msgs::PoseCommandArray_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace r2_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': True}
// {'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg'], 'r2_msgs': ['/tmp/buildd/ros-hydro-r2-msgs-1.0.0-1raring-20150329-2316/msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'visualization_msgs': ['/opt/ros/hydro/share/visualization_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::r2_msgs::PoseCommandArray_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::r2_msgs::PoseCommandArray_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::r2_msgs::PoseCommandArray_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::r2_msgs::PoseCommandArray_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::r2_msgs::PoseCommandArray_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::r2_msgs::PoseCommandArray_<ContainerAllocator> const>
  : TrueType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::r2_msgs::PoseCommandArray_<ContainerAllocator> >
{
  static const char* value()
  {
    return "fd9b3b03f805dcb412e07ffc694f2684";
  }

  static const char* value(const ::r2_msgs::PoseCommandArray_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xfd9b3b03f805dcb4ULL;
  static const uint64_t static_value2 = 0x12e07ffc694f2684ULL;
};

template<class ContainerAllocator>
struct DataType< ::r2_msgs::PoseCommandArray_<ContainerAllocator> >
{
  static const char* value()
  {
    return "r2_msgs/PoseCommandArray";
  }

  static const char* value(const ::r2_msgs::PoseCommandArray_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::r2_msgs::PoseCommandArray_<ContainerAllocator> >
{
  static const char* value()
  {
    return "Header header\n\
PoseCommand[] command\n\
\n\
================================================================================\n\
MSG: std_msgs/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.secs: seconds (stamp_secs) since epoch\n\
# * stamp.nsecs: nanoseconds since stamp_secs\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
\n\
================================================================================\n\
MSG: r2_msgs/PoseCommand\n\
# A Pose with reference coordinate frame, chain definition, and command_id\n\
string commandId\n\
string refFrame\n\
geometry_msgs/Pose pose\n\
string baseFrame\n\
string toolFrame\n\
\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Pose\n\
# A representation of pose in free space, composed of postion and orientation. \n\
Point position\n\
Quaternion orientation\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Point\n\
# This contains the position of a point in free space\n\
float64 x\n\
float64 y\n\
float64 z\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Quaternion\n\
# This represents an orientation in free space in quaternion form.\n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
float64 w\n\
";
  }

  static const char* value(const ::r2_msgs::PoseCommandArray_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::r2_msgs::PoseCommandArray_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.header);
      stream.next(m.command);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct PoseCommandArray_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::r2_msgs::PoseCommandArray_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::r2_msgs::PoseCommandArray_<ContainerAllocator>& v)
  {
    s << indent << "header: ";
    s << std::endl;
    Printer< ::std_msgs::Header_<ContainerAllocator> >::stream(s, indent + "  ", v.header);
    s << indent << "command[]" << std::endl;
    for (size_t i = 0; i < v.command.size(); ++i)
    {
      s << indent << "  command[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::r2_msgs::PoseCommand_<ContainerAllocator> >::stream(s, indent + "    ", v.command[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // R2_MSGS_MESSAGE_POSECOMMANDARRAY_H
