/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-r2-msgs-1.0.0-1raring-20150329-2316/msg/TorsoStatus.msg
 *
 */


#ifndef R2_MSGS_MESSAGE_TORSOSTATUS_H
#define R2_MSGS_MESSAGE_TORSOSTATUS_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace r2_msgs
{
template <class ContainerAllocator>
struct TorsoStatus_
{
  typedef TorsoStatus_<ContainerAllocator> Type;

  TorsoStatus_()
    : leftarm()
    , rightarm()
    , neck()
    , lefthand()
    , righthand()
    , waist()  {
    }
  TorsoStatus_(const ContainerAllocator& _alloc)
    : leftarm(_alloc)
    , rightarm(_alloc)
    , neck(_alloc)
    , lefthand(_alloc)
    , righthand(_alloc)
    , waist(_alloc)  {
    }



   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _leftarm_type;
  _leftarm_type leftarm;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _rightarm_type;
  _rightarm_type rightarm;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _neck_type;
  _neck_type neck;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _lefthand_type;
  _lefthand_type lefthand;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _righthand_type;
  _righthand_type righthand;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _waist_type;
  _waist_type waist;




  typedef boost::shared_ptr< ::r2_msgs::TorsoStatus_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::r2_msgs::TorsoStatus_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct TorsoStatus_

typedef ::r2_msgs::TorsoStatus_<std::allocator<void> > TorsoStatus;

typedef boost::shared_ptr< ::r2_msgs::TorsoStatus > TorsoStatusPtr;
typedef boost::shared_ptr< ::r2_msgs::TorsoStatus const> TorsoStatusConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::r2_msgs::TorsoStatus_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::r2_msgs::TorsoStatus_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace r2_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg'], 'r2_msgs': ['/tmp/buildd/ros-hydro-r2-msgs-1.0.0-1raring-20150329-2316/msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'visualization_msgs': ['/opt/ros/hydro/share/visualization_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::r2_msgs::TorsoStatus_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::r2_msgs::TorsoStatus_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::r2_msgs::TorsoStatus_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::r2_msgs::TorsoStatus_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::r2_msgs::TorsoStatus_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::r2_msgs::TorsoStatus_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::r2_msgs::TorsoStatus_<ContainerAllocator> >
{
  static const char* value()
  {
    return "2334ce336aad886ccb87a294113ed892";
  }

  static const char* value(const ::r2_msgs::TorsoStatus_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x2334ce336aad886cULL;
  static const uint64_t static_value2 = 0xcb87a294113ed892ULL;
};

template<class ContainerAllocator>
struct DataType< ::r2_msgs::TorsoStatus_<ContainerAllocator> >
{
  static const char* value()
  {
    return "r2_msgs/TorsoStatus";
  }

  static const char* value(const ::r2_msgs::TorsoStatus_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::r2_msgs::TorsoStatus_<ContainerAllocator> >
{
  static const char* value()
  {
    return "string leftarm\n\
string rightarm\n\
string neck\n\
string lefthand\n\
string righthand\n\
string waist\n\
";
  }

  static const char* value(const ::r2_msgs::TorsoStatus_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::r2_msgs::TorsoStatus_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.leftarm);
      stream.next(m.rightarm);
      stream.next(m.neck);
      stream.next(m.lefthand);
      stream.next(m.righthand);
      stream.next(m.waist);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct TorsoStatus_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::r2_msgs::TorsoStatus_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::r2_msgs::TorsoStatus_<ContainerAllocator>& v)
  {
    s << indent << "leftarm: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.leftarm);
    s << indent << "rightarm: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.rightarm);
    s << indent << "neck: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.neck);
    s << indent << "lefthand: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.lefthand);
    s << indent << "righthand: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.righthand);
    s << indent << "waist: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.waist);
  }
};

} // namespace message_operations
} // namespace ros

#endif // R2_MSGS_MESSAGE_TORSOSTATUS_H
